import { LambdaHandler } from "../lambda";
import { IRequest } from "./request";
import { IResponse } from "./response";
import { Formatter } from "./response/formatter";
export interface IHandlerParams {
    req?: IRequest;
    res?: IResponse;
    event?: {};
    context?: {};
}
export declare type Handler = (params: IHandlerParams) => Promise<any> | any;
export declare type HandlerCreator = (handler: Handler) => LambdaHandler;
export interface IHandlerCreatorOptions {
    formatters?: Formatter[];
    middleware?: Handler;
}
export declare function buildHandlerCreator(options?: IHandlerCreatorOptions): HandlerCreator;
