"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const request_1 = require("./request");
const response_1 = require("./response");
const error_1 = require("./response/error");
function buildHandlerCreator(options = {}) {
    options = Object.assign({
        formatters: [],
        middleware: ({}) => Promise.resolve([]),
    }, options);
    return (handler) => ({ event, context }) => __awaiter(this, void 0, void 0, function* () {
        const res = new response_1.Response(options.formatters);
        try {
            const req = new request_1.Request(event);
            const params = { req, res, event, context };
            yield Promise.resolve(options.middleware(params));
            if (!res.hasErrorStatusCode) {
                res.send(yield Promise.resolve(handler(params)));
            }
        }
        catch (err) {
            res.error(error_1.ErrorStatuses.InternalServerError, err);
        }
        return res.format();
    });
}
exports.buildHandlerCreator = buildHandlerCreator;
