"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const event_1 = require("./event");
class Request {
    constructor(event) {
        this.event = event;
    }
    get method() {
        return this.event.httpMethod;
    }
    get body() {
        return this.event.body || null;
    }
    header(key, defaultValue) {
        return event_1.getParamValue(this.event.headers, key, defaultValue || "");
    }
    context(key) {
        return event_1.getParamValue(this.event.requestContext, key);
    }
    param(key, defaultValue) {
        return event_1.getParamValue(this.event.pathParameters, key, defaultValue);
    }
    query(key, defaultValue) {
        return event_1.getParamValue(this.event.queryStringParameters, key, defaultValue);
    }
}
exports.Request = Request;
