import { IOutgoingEvent } from "./event";
import { Formatter } from "./response/formatter";
export interface IResponse {
    hasErrorStatusCode: boolean;
    status(statusCode: number): this;
    header(name: string, value: string | boolean): this;
    error(statusCode: number, error?: any): void;
    send(body?: string): void;
    format(formatters: Formatter[]): IOutgoingEvent;
}
export declare class Response implements IResponse {
    private formatters;
    private data;
    constructor(formatters?: Formatter[]);
    readonly hasErrorStatusCode: boolean;
    status(statusCode: number): this;
    header(name: string, value: string | boolean): this;
    error(status: number, body?: any): void;
    send(body?: any): void;
    format(): IOutgoingEvent;
}
