"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const error_1 = require("../error");
exports.JSON_HEADERS = {
    "Content-Type": "application/json",
};
exports.jsonFormatter = ({ statusCode, body }) => {
    const status = error_1.ErrorStatuses[statusCode];
    if (status) {
        let message;
        switch (typeof body) {
            case "string":
                message = body;
                break;
            case "object":
                message = body.message;
                break;
        }
        body = {
            status,
            message,
        };
    }
    return {
        headers: exports.JSON_HEADERS,
        body: JSON.stringify(body),
    };
};
